<ng-container *ngIf="topology; else elseBlock">
    <ng-container *ngTemplateOutlet="nodeTemplate; context: {context: topology.root}" ></ng-container>
</ng-container>
<ng-template #elseBlock>
    No topology.
</ng-template>

<ng-template #nodeTemplate let-model="context">
    <ng-container *ngIf="toNode(model); let node">

        <div [class]="'flex-center column topology-node topology-node-' + getNodeTypeName(node.nodeType)">
            <div class="topology-node-name-container">
                <div class="topology-node-name">
                    {{node.name}}
                </div>
                <ng-container *ngIf="node.osIndex !== undefined">
                    <div class="topology-node-index">
                        {{node.osIndex}}
                    </div>
                    <div *ngIf="shouldShowAffinityBox(node)" class="topology-node-checkbox">
                        <app-icon [iconName]="'checkmark'"></app-icon>
                    </div>
                </ng-container>
                <div *ngIf="node.value" class="topology-node-value">
                    {{this.valueConverter.toStringIEC(node.value, 'B', 0)}}
                </div>
            </div>

            <ng-container *ngIf="node.memoryChildren">
                <div class="topology-memoryChildren-container">
                    <ng-container *ngFor="let child of node.memoryChildren">
                        <ng-container  *ngTemplateOutlet="nodeTemplate; context: {context: child}" ></ng-container>
                    </ng-container>
                </div>
            </ng-container>

            <ng-container *ngIf="node.children">
                <div class="topology-children-container">
                    <ng-container  *ngFor="let child of node.children">
                        <ng-container *ngTemplateOutlet="nodeTemplate; context: {context: child}" ></ng-container>
                    </ng-container>
                </div>
            </ng-container>
        </div>
    </ng-container>
</ng-template>
